#include "signature.h"

// $B%O%C%7%e4X?t(B
static int hashpjw(unsigned char *s, int len)
{
  unsigned h=0, g;
  for(;*s && (len-- > 0);s++){
    h = (h << 4) + (*s);
    if(g = h & 0xf0000000){
      h = h ^ (g >> 24);
      h = h ^ g;
    }
  }
  return h;
}

// Signature$B$r7W;;$7$F(Bsig$B$K3JG<(B
void calcsig(unsigned char *s, char *sig)
{
  int i,v;
  for(i=0;i<SIGBYTES;i++) sig[i] = 0x40;
  sig[SIGBYTES] = 0;
  for(;*s && *(s+1) && *(s+2);s++){
    v = hashpjw(s,3) % SIGBITS;
    sig[v/6] |= (1 << v%6);
  }
  for(i=0;i<SIGBYTES;i++) 
    if(sig[i] == 0x7f) sig[i] = 0x3f;
}

// Signature$B$NHf3S(B
int sigmatch(char *textsig, char *patsig)
{
  int i;
  char c;
  for(i=0;i<SIGBYTES;i++){
    c = patsig[i] & 0x3f;
    if((textsig[i] & c) != c) return 0;
  }
  return 1;
}
